package com.smardec.demo.tools;

import com.smardec.j2native.Library;

import java.util.HashMap;
import java.util.Iterator;


public class LibraryManager{
    private static LibraryManager instance;
    private HashMap libMap;

    public static final LibraryManager getInstance(){
        if(instance == null){
            instance = new LibraryManager();
        }
        return instance;
    }

    private LibraryManager(){
        this.libMap = new HashMap();
    }


    public boolean registerLibrary(Library library){
        if(!libMap.containsKey(library.getName())){
            libMap.put(library.getName(), library);
            library.load();
            return true;
        }
        return false;
    }

    public boolean unregisterLibrary(String libName){
        Library library = (Library)libMap.remove(libName);
        if(library != null){
            library.unload();
            return true;
        }
        return false;
    }

    public Library getLibrary(String libName){
        return (Library)libMap.get(libName);
    }

    public void reset(){
        Iterator iterator = libMap.keySet().iterator();
        while(iterator.hasNext()){
            Library library = (Library)libMap.get(iterator.next());
            library.unload();
        }
        libMap.clear();
    }

}
